<?php

namespace Magento\FDPPaymentGateway\Block;

class OrderPayment extends \Magento\Framework\View\Element\Template
{	
	protected $_coreRegistry = null;
	protected $scopeConfig;
	
	public function __construct(
		\Magento\Framework\View\Element\Template\Context $context,
		\Magento\Framework\Registry $registry,
		\Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig
	)
	{		
		$this->_coreRegistry = $registry;
		$this->scopeConfig = $scopeConfig;
		parent::__construct($context);
	}

	public function getOrder()
	{
		return $this->_coreRegistry->registry('current_order');
	}
	
	public function getKey()
	{
		$order = $this->getOrder();
		return md5($order->getId() . $this->scopeConfig->getValue('payment/fdp_gateway/key'));
	}

	public function isFdp() {
		$payment = $this->getOrder()->getPayment();
		return ($payment->getMethod() == 'fdp_gateway');
	}

	public function viewPayment()
	{
		$payment = $this->getOrder()->getPayment();
		return isset(\Magento\FDPPaymentGateway\Helper\Request::$statusy[$payment->getData('fdp_status')]) ? \Magento\FDPPaymentGateway\Helper\Request::$statusy[$payment->getData('fdp_status')] : '???';
	}

	function showZwrot() {
		if(!$this->scopeConfig->getValue('payment/fdp_gateway/zarzadzanie')) return false;
		if($this->amountPaid() <= 0) return false;
		$payment = $this->getOrder()->getPayment();
		if(!in_array($payment->getData('fdp_status'), array(20, 30, 35, 50))) return false;
		return true;
	}
	
	function showAnulacja() {
		return 0;
		return ($this->scopeConfig->getValue('payment/fdp_gateway/zarzadzanie'));
	}
	
	function showZatwierdzenie() {
		return 0;
		return ($this->scopeConfig->getValue('payment/fdp_gateway/zarzadzanie'));
	}

	function amountPaid() {
		return $this->getOrder()->getBaseTotalPaid() - $this->getOrder()->getBaseTotalRefunded();
	}

	function currPaid() {
		return $this->getOrder()->getBaseCurrencyCode();
	}

}

?>