<?php

namespace Magento\FDPPaymentGateway\Controller\Helper;

class Total extends \Magento\Framework\App\Action\Action
{
	protected $_pageFactory;
	protected $scopeConfig;
	protected $quoteFactory;

	public function __construct(
		\Magento\Framework\App\Action\Context $context,
		\Magento\Framework\View\Result\PageFactory $pageFactory,
		\Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
		\Magento\Quote\Model\QuoteFactory $quoteFactory
	)
	{
		$this->_pageFactory = $pageFactory;
		$this->scopeConfig = $scopeConfig;
		$this->quoteFactory = $quoteFactory;
		return parent::__construct($context);
	}

	public function execute()
	{
		$json = json_decode(file_get_contents('php://input'), true);
		$objectManager = \Magento\Framework\App\ObjectManager::getInstance();
		$orderCol = $objectManager->create('Magento\Sales\Model\Order')->getCollection()->addAttributeToFilter('quote_id', $json['order_id'])->load();
		if($orderCol->getTotalCount() != 1) $ret = array('error' => 'Bad quote id: ' . $json['order_id']);
		else {
			foreach($orderCol as $o) $order = $o;
			if(!$order) $ret = array('error' => 'Invalid quote id: ' . $json['order_id']);
			elseif($order->getCustomerEmail() != $json['email']) $ret = array('error' => 'Invalid email');
			elseif($order->getBaseSubtotal() != $json['amount']) $ret = array('error' => 'Invalid total');
			else $ret = array('total' => $order->getBaseGrandTotal(), 'order_id' => $order->getId(), 'sess' => md5('' . $order->getId() . $this->scopeConfig->getValue('payment/fdp_gateway/key')));
		}
		
		$this->getResponse()->setHeader('Content-type', 'application/json');
		$this->getResponse()->setBody(json_encode($ret));
		$this->getResponse()->sendResponse();
		exit;
	}

}
