<?php 

namespace Magento\FDPPaymentGateway\Setup;

use Magento\Framework\Setup\UpgradeSchemaInterface;
use Magento\Framework\Setup\ModuleContextInterface;
use Magento\Framework\Setup\SchemaSetupInterface;

class UpgradeSchema implements UpgradeSchemaInterface
{

	public function upgrade(SchemaSetupInterface $setup, ModuleContextInterface $context) {
		$setup->startSetup();
		$tableName = $setup->getTable('sales_order_payment');
		
		$setup->getConnection()->addColumn(
			$tableName,
			'fdp_status',
			[
				'type' => \Magento\Framework\DB\Ddl\Table::TYPE_SMALLINT,
				'nullable' => true,
				'default' => 0,
				'comment' => 'FDP transaction status'
			]
		);
		
		$setup->endSetup();
	}
}

?>