
define(
    [
    	'jquery',
        'Magento_Checkout/js/view/payment/default',
        'Magento_Paypal/js/action/set-payment-method',
        'Magento_Customer/js/model/customer',
        'Magento_Customer/js/customer-data',
        'Magento_Checkout/js/model/quote'
    ],
    function ($, Component, setPaymentMethodAction, customer, customerData, quote) {
        'use strict';

        return Component.extend({
            defaults: {
                template: 'Magento_FDPPaymentGateway/payment/form',
                transactionResult: '',
                redirectAfterPlaceOrder: false
            },

            getCode: function() {
                return 'fdp_gateway';
            },

            getLogo: function () {
                return window.checkoutConfig.payment.fdp_gateway.logo;
            },

            afterPlaceOrder: function() {
       			var location = window.checkoutConfig.payment.fdp_gateway.gateway;
       			var bd = quote.billingAddress();
       			var mail = null;
       			if(!customer.isLoggedIn()) mail = quote.guestEmail;
       			else mail = window.checkoutConfig.customerData.email;
       			var d = {
       				pos_id: window.checkoutConfig.payment.fdp_gateway.pos_id,
       				order_id: window.checkoutConfig.payment.fdp_gateway.id,
       				session_id: '',
       				amount: window.checkoutConfig.quoteData.base_subtotal,
       				currency: window.checkoutConfig.quoteData.base_currency_code,
       				test: (window.checkoutConfig.payment.fdp_gateway.test == 1 ? 'Y' : 'N'),
       				language: window.checkoutConfig.payment.fdp_gateway.lang,
       				client_ip: window.checkoutConfig.quoteData.remote_ip,
       				street: '',
       				street_n1: '',
       				street_n2: '',
       				city: '',
       				postcode: '',
       				country: bd.countryId,
       				email: mail.substring(0, 40),
       				ba_firstname: '',
       				ba_lastname: ''
       			};
       			var jtotal = $.ajax({
       				type: "POST",
       				dataType: "json",
       		        url: '../fdp/helper/total',
       		        contentType: "application/json; charset=utf-8",
       		        data: JSON.stringify(d),
       		        async: false
       		    }).responseText;
       			var total = JSON.parse(jtotal);
       			d['amount'] = '' + Math.round(total.total * 100);
       			d['order_id'] = total.order_id;
       			d['session_id'] = total.sess;
       			var jcdata = $.ajax({
       				type: "POST",
       				dataType: "json",
       		        url: '../fdp/helper/cdata',
       		        contentType: "application/json; charset=utf-8",
       		        data: JSON.stringify(d),
       		        async: false
       		    }).responseText;
       			var cdata = JSON.parse(jcdata);
       			d['controlData'] = cdata.cdata;
    			var form = '';
    			$.each(d, function(key, value) {
    	            if(value) value = value.split('"').join('\"')
    	            form += '<input type="hidden" name="'+key+'" value="'+value+'">';
    	        });
    	        $('<form action="' + location + '" method="POST">' + form + '</form>').appendTo($(document.body)).submit();
            }
        });
    }
);
